import systemFS from "fs";
type FS = typeof systemFS;
type Options = {
    directory?: string;
    include_file?: string | RegExp;
    exclude_file?: string | RegExp;
    include_dir?: string | RegExp;
    exclude_dir?: string | RegExp;
    fs?: FS;
};
declare function some(match: (file: string) => boolean | Promise<boolean>, options: Options): Promise<boolean>;
declare function every(match: (file: string) => boolean | Promise<boolean>, options: Options): Promise<boolean>;
declare function filter(match: (file: string) => boolean | Promise<boolean>, options: Options): Promise<Array<string>>;
declare function forEach(apply: (file: string) => void | Promise<void>, options: Options): Promise<void>;
declare const traverse: (<T>(options: Options & {
    process_file: (filepath: string) => T;
}) => Promise<Array<T>>) & {
    traverse: <T>(options: Options & {
        process_file: (filepath: string) => T;
    }) => Promise<Array<T>>;
    some: typeof some;
    every: typeof every;
    filter: typeof filter;
    forEach: typeof forEach;
};
export { traverse, some, every, filter, forEach };
export default traverse;
